/**
 * App Insights Configuration Contract
 *
 * @export
 * @interface Config
 */
export interface Config {
    instrumentationKey: string;
    endpointUrl?: string;
    accountId?: string;
    sessionRenewalMs?: number;
    sessionExpirationMs?: number;
    maxBatchSizeInBytes?: number;
    maxBatchInterval?: number;
    enableDebug?: boolean;
    disableTelemetry?: boolean;
    verboseLogging?: boolean;
    samplingPercentage?: boolean;
    diagnosticLogInterval?: number;
    disableExceptionTracking?: boolean;
    disableAjaxTracking?: boolean;
    overridePageViewDuration?: boolean;
    maxAjaxCallsPerView?: number;
    isCookieUseDisabled?: boolean;
    cookieDomain?: string;
    disableFlushOnBeforeUnload?: boolean;
    enableSessionStorageBuffer?: boolean;
    isRetryDisabled?: boolean;
    url?: string;
    isStorageUseDisabled?: boolean;
    [index: string]: any;
}
